package net.stefankrause.jbpm;

import java.util.ArrayList;

import org.drools.event.process.ProcessCompletedEvent;
import org.drools.event.process.ProcessEventListener;
import org.drools.event.process.ProcessNodeLeftEvent;
import org.drools.event.process.ProcessNodeTriggeredEvent;
import org.drools.event.process.ProcessStartedEvent;
import org.drools.event.process.ProcessVariableChangedEvent;

public class EvtListener implements ProcessEventListener {

	private ArrayList<String> nodesVisited = new ArrayList<String>();

	public String lastNode;
	private boolean ended = false;
	
	public ArrayList<String> getNodesVisited() {
		return nodesVisited;
	}
	
	public boolean isProcessEnded() {
		return ended;
	}
	
	@Override
	public void beforeVariableChanged(ProcessVariableChangedEvent arg0) {
	}

	@Override
	public void beforeProcessStarted(ProcessStartedEvent arg0) {
		System.out.println("Before start");
	}

	@Override
	public void beforeProcessCompleted(ProcessCompletedEvent arg0) {
	}

	@Override
	public void beforeNodeTriggered(ProcessNodeTriggeredEvent arg0) {
	}

	@Override
	public void beforeNodeLeft(ProcessNodeLeftEvent arg0) {
		nodesVisited.add(arg0.getNodeInstance().getNodeName());
		System.out.println("==> Node "+arg0.getNodeInstance().getNodeName());
		lastNode = arg0.getNodeInstance().getNodeName();
	}

	@Override
	public void afterVariableChanged(ProcessVariableChangedEvent arg0) {
	}

	@Override
	public void afterProcessStarted(ProcessStartedEvent arg0) {
	}

	@Override
	public void afterProcessCompleted(ProcessCompletedEvent arg0) {
		System.out.println("==> Process completed "+arg0.getProcessInstance().getId());
		ended = true;
	}

	@Override
	public void afterNodeTriggered(ProcessNodeTriggeredEvent arg0) {
	}

	@Override
	public void afterNodeLeft(ProcessNodeLeftEvent arg0) {
//		System.out.println("After node "+arg0.getNodeInstance().getNodeName());
	}
}