package net.stefankrause.jbpm.tests;

import junit.framework.Assert;
import net.stefankrause.jbpm.EvtListener;
import net.stefankrause.jbpm.ProcessRunner;

import org.drools.runtime.StatefulKnowledgeSession;
import org.junit.Test;

public class TimerPersistenceTest  {
	
	@Test
	public void testTimerPersistence() throws Exception {
		
		ProcessRunner runner = new ProcessRunner(null, "TimerPersistence.bpmn2", false);
		EvtListener listener = new EvtListener();
		StatefulKnowledgeSession ksession = runner.getKsession();
		int sessionId = ksession.getId();
		ksession.addEventListener(listener);
		org.drools.runtime.process.WorkflowProcessInstance process = (org.drools.runtime.process.WorkflowProcessInstance) ksession.startProcess("TimerPersistence", null);
//		Beware the NPE
//		Assert.assertEquals("Timer", process.getNodeInstances().iterator().next().getNodeName());
		
		runner.shutDown();

		Assert.assertTrue("Left was triggered", listener.getNodesVisited().contains("Left"));
		Assert.assertFalse("Right was not yes triggered", listener.getNodesVisited().contains("Right"));
		
		ProcessRunner runner2 = new ProcessRunner(sessionId, "TimerPersistence.bpmn2", false);
		EvtListener listener2= new EvtListener();
		StatefulKnowledgeSession ksession2 = runner2.getKsession();
		ksession2.addEventListener(listener2);
		ksession2.startProcess("TimerPersistence", null).getId();
		
		Thread.sleep(10 * 1024);
		
		runner2.shutDown();
		
		Assert.assertTrue("Left was triggered", listener2.getNodesVisited().contains("Left"));
		Assert.assertTrue("Right was triggered", listener2.getNodesVisited().contains("Right"));
	}
	
}
